
public class Optimierung
{
    //RungeKuttaIntegrator ruku = new RungeKuttaIntegrator(new SchwingerModell());
    RungeKuttaIntegrator ruku;
    AutonomesVehikel modell;
    double[] yalt,yneu;
    double x,y,phi,vx,vy,omega,t,dt; //Aktueller Zustand des Fahrzeugs, Meter Meter rad
    
    public Optimierung()
    {
        Par.initialisieren(640,480);
        
        modell = new AutonomesVehikel();
        ruku = new RungeKuttaIntegrator(modell);

        yalt = new double[modell.holeAnzahlGleichungen()];
        yneu = new double[modell.holeAnzahlGleichungen()];
        initialisieren();
        
    }
    
    public void initialisieren()
    {
            x=0.0;
            y=-0.3;
            phi=0.0;
            vx=0.0;
            vy=0.0;                        
            omega=0.0;
            t=0.0;
            dt=0.01;
        
            yalt[0]=x;
            yalt[1]=y;
            yalt[2]=phi;
            yalt[3]=vx;
            yalt[4]=vy;
            yalt[5]=omega;
            
            for(int i=0;i<yalt.length;i++)
                yneu[i]=yalt[i];
    }

    public double berechneFehler(double[] par)
    {
        boolean FERTIG = false;
        initialisieren();
        modell.PWERT    = par[0];
        modell.SOLLWERT = par[1];
        
        while(!FERTIG)
        {
            for(int i=0;i<10;i++)
            {
                for(int k=0;k<yalt.length;k++)
                   yalt[k]=yneu[k];
                yneu = ruku.berechneZeitschritt(yalt,t,dt);    
                t+=dt;            
            }
            x=yalt[0];
            y=yalt[1];
            phi=yalt[2];
            vx=yalt[3];
            vy=yalt[4];
            omega=yalt[5];        
            
            modell.aktualisiereSensorwert(x,y,phi);
            
            if(modell.rundeVollendet(x,y,phi))
            {
                FERTIG=true;
            }
            
            if(modell.kollision(x,y,phi))    
            {
                FERTIG=true;
                t=300.0; //>> als gewöhnliche Rundenzeit als "Strafe"               
            }
            
            
        } 
        
        return t;
    }
    
    public static void main(String[] args)
    {
//        double PWERT = 0.0005;
        double PWERT = 0.0008;
        double SOLLWERT = 50.0;
        
        Optimierung opt = new Optimierung();
        
        double[] par = {PWERT,SOLLWERT};
        
        double testfehler = opt.berechneFehler(par);
        System.out.println("FEHLER = "+testfehler);
        
    }
}

